<?php
namespace Teknisa\PLA\Modules\Requisicao\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use \Setforms2\Shared\ORM\DateTime;
use Zeedhi\Framework\Report\ReportService;

class Pla00601RequisicaoServicoRelatorio extends \Zeedhi\Framework\Controller\Report {

    protected $qr2Strategy;
    protected $Pla00600RequisicaoServico;

    public function __construct($Pla00600RequisicaoServico, ReportService $reportService, $entityManager, $qr2Strategy) {
      $this->Pla00600RequisicaoServico = $Pla00600RequisicaoServico;
      $this->entityManager   = $entityManager;
      $this->qr2Strategy     = $qr2Strategy;
      parent::__construct($reportService);
    }

    protected $reportMapping = array (
      'pla00600' =>
      array (
        'strategy' => 'QR2',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD' => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA' => 'P_NRLINHABRANCA',
          'CDOPERADOR' => 'P_CDOPERADOR',
          'NMOPERADOR' => 'P_NMOPERADOR',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'TODOS' => 'P_TODOS',
          'DTINICIAL' => 'P_DTINICIAL',
          'DTFINAL' => 'P_DTFINAL',
          'IDCARD' => 'P_IDCARD',
          'IDFIXO' => 'P_IDFIXO',
          'IDPERC' => 'P_IDPERC',
          'ORDENA' => 'P_ORDENA',
          'TAMNIV' => 'P_TAMNIV',
        )
      ),
      'pla00601' =>
      array (
        'strategy' => 'QR2',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD' => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA' => 'P_NRLINHABRANCA',
          'CDOPERADOR' => 'P_CDOPERADOR',
          'NMOPERADOR' => 'P_NMOPERADOR',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'TODOS' => 'P_TODOS',
          'DTINICIAL' => 'P_DTINICIAL',
          'DTFINAL' => 'P_DTFINAL',
          'IDCARD' => 'P_IDCARD',
          'IDFIXO' => 'P_IDFIXO',
          'IDPERC' => 'P_IDPERC',
          'ORDENA' => 'P_ORDENA',
          'TAMNIV' => 'P_TAMNIV',
        )
      ),
      'pla00602' =>
      array (
        'strategy' => 'QR2',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD' => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA' => 'P_NRLINHABRANCA',
          'CDOPERADOR' => 'P_CDOPERADOR',
          'NMOPERADOR' => 'P_NMOPERADOR',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'TODOS' => 'P_TODOS',
          'DTINICIAL' => 'P_DTINICIAL',
          'DTFINAL' => 'P_DTFINAL',
          'IDCARD' => 'P_IDCARD',
          'IDFIXO' => 'P_IDFIXO',
          'IDPERC' => 'P_IDPERC',
          'ORDENA' => 'P_ORDENA',
          'TAMNIV' => 'P_TAMNIV',
        )
      ),
      'pla00603' =>
      array (
        'strategy' => 'QR2',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD' => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA' => 'P_NRLINHABRANCA',
          'CDOPERADOR' => 'P_CDOPERADOR',
          'NMOPERADOR' => 'P_NMOPERADOR',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'TODOS' => 'P_TODOS',
          'DTINICIAL' => 'P_DTINICIAL',
          'DTFINAL' => 'P_DTFINAL',
          'IDCARD' => 'P_IDCARD',
          'IDFIXO' => 'P_IDFIXO',
          'IDPERC' => 'P_IDPERC',
          'ORDENA' => 'P_ORDENA',
          'TAMNIV' => 'P_TAMNIV',
          'NRCONSPLAN' => 'P_NRCONSPLAN',
          'CDLCLIPENT' => 'P_CDLCLIPENT',
          'CDTCLIPENT' => 'P_CDTCLIPENT',
        )
      ),
      'pla00604' =>
      array (
        'strategy' => 'QR2',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD' => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA' => 'P_NRLINHABRANCA',
          'CDOPERADOR' => 'P_CDOPERADOR',
          'NMOPERADOR' => 'P_NMOPERADOR',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'TODOS' => 'P_TODOS',
          'DTINICIAL' => 'P_DTINICIAL',
          'DTFINAL' => 'P_DTFINAL',
          'IDCARD' => 'P_IDCARD',
          'IDFIXO' => 'P_IDFIXO',
          'IDPERC' => 'P_IDPERC',
          'ORDENA' => 'P_ORDENA',
          'TAMNIV' => 'P_TAMNIV',
        )
      ),
      'pla00605' =>
      array (
        'strategy' => 'QR2',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD' => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA' => 'P_NRLINHABRANCA',
          'CDOPERADOR' => 'P_CDOPERADOR',
          'NMOPERADOR' => 'P_NMOPERADOR',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'TODOS' => 'P_TODOS',
          'DTINICIAL' => 'P_DTINICIAL',
          'DTFINAL' => 'P_DTFINAL',
          'IDCARD' => 'P_IDCARD',
          'IDFIXO' => 'P_IDFIXO',
          'IDPERC' => 'P_IDPERC',
          'ORDENA' => 'P_ORDENA',
          'TAMNIV' => 'P_TAMNIV',
        )
      ),
      'pla00609' =>
      array (
        'strategy' => 'QR2',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD' => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA' => 'P_NRLINHABRANCA',
          'CDOPERADOR' => 'P_CDOPERADOR',
          'NMOPERADOR' => 'P_NMOPERADOR',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'TODOS' => 'P_TODOS',
          'DTINICIAL' => 'P_DTINICIAL',
          'DTFINAL' => 'P_DTFINAL',
          'IDCARD' => 'P_IDCARD',
          'IDFIXO' => 'P_IDFIXO',
          'IDPERC' => 'P_IDPERC',
          'ORDENA' => 'P_ORDENA',
          'TAMNIV' => 'P_TAMNIV',
        )
      )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
            if ($row['CDSERVFILI'] == "T") {
              $row['CDSERVFILI'] = $this->Pla00600RequisicaoServico->retornaServicos($row);
              $row['TODOS'] = $row['CDSERVFILI'];
            }

        } catch (\Exception $e) {

            $response->setError(new Error($e->getMessage(), 1));

        }
    }

}